//PicoWSPR 40m/30m
#include "vfo3.pio.h"
#include "pico/stdlib.h"
#include "pico/multicore.h"
#include <JTEncode.h>
JTEncode jtencode;

char call[] = "T2EST";  //Rufzeichen
char loc[] = "JO31";    //Lacotor 
uint8_t dbm = 10;       //10 mW
uint8_t tx_buffer[255];


uint32_t clk_khz = 150000;
uint32_t f; 
volatile uint32_t periods;
  
void setup(void){
  set_sys_clock_khz(clk_khz,true);
  Serial.begin(9600);
  gpio_init(0);
  gpio_set_dir(0,0);
  gpio_pull_up(0);
}

void set_freq(void){
  uint64_t ratio = (uint64_t)clk_khz*1000LL *(1<<24)/(uint64_t)f;
  periods=(uint32_t)ratio; 
}

void encode(){
  uint32_t wsfr[4];
  set_freq();
  uint32_t dwsfr= 146L * (periods/f)/ 100L ;
  wsfr[0]= periods-(10<<24);  // + 3 x Abstand 1,46 Hz
  wsfr[1]= wsfr[0]-dwsfr;
  wsfr[2]= wsfr[1]-dwsfr;
  wsfr[3]= wsfr[2]-dwsfr;
  wsfr[0]>>=1;   //Perioden /2
  wsfr[1]>>=1;
  wsfr[2]>>=1;
  wsfr[3]>>=1;
  
  memset(tx_buffer, 0, 255);
  jtencode.wspr_encode(call, loc, dbm, tx_buffer);
  uint16_t n=0;
  while(1){
    for(uint8_t i = 0; i < 162; i++)
    {
      periods=wsfr[tx_buffer[i]];
      delay(683);
    }
    periods = 0;
    n++;
    delay(9350);             //Restzeit bis 2 Min
    if (n>2){delay(360000);} //6 Min Pause
  }
}

void loop(){
  if (gpio_get(0)==0){
    f=7040100;  //40m
  }  
  else{
    f=10140200; //30m
  }
  delay (50);
  encode();
  while(1){}
}

void setup1(void){
  PIO pio = pio0;
  gpio_init(0);
  gpio_set_dir(0, GPIO_OUT);
  pio_gpio_init(pio0, 15);         
  pio_gpio_init(pio0, 14);         
  pio_gpio_init(pio0, 13);         
  pio_gpio_init(pio0, 12);         
  uint offset = pio_add_program(pio0, &vfo_program);         
  pio_sm_set_consecutive_pindirs(pio0, 0, 12, 4, true);          
  pio_sm_config c = vfo_program_get_default_config(offset); 
  sm_config_set_set_pins(&c, 12, 4);                  
  pio_sm_init(pio0, 0, offset, &c);       
  pio_sm_set_enabled(pio0, 0, true); 
  periods=0;
}

void vco(){
  uint16_t t;
  uint32_t delta;
  while(periods>0){
    t = (periods+delta) >> 24;  
    pio_sm_put_blocking(pio0, 0, t);
    delta += periods-(t << 24);      
  }  
}

void loop1(){
  vco();
} 
